routes/admin.php
<?php

use App\Http\Controllers\ProfileController;
use App\Http\Controllers\UserController;
use App\Http\Controllers\TaskController;
use Illuminate\Support\Facades\Route;

Route::prefix('admin')->name('admin.')->middleware(['auth', 'verified'])->group(function () {
    Route::get('/dashboard',[ProfileController::class,'dashboard'])->name('dashboard');
    Route::get('/profile', [ProfileController::class, 'edit'])->name('profile.edit');
    Route::patch('/profile', [ProfileController::class, 'update'])->name('profile.update');
    Route::delete('/profile', [ProfileController::class, 'destroy'])->name('profile.destroy');
    Route::resource('task',TaskController::class);
    Route::middleware(['role:admin'])->group(function(){
        Route::resource('user',UserController::class);
    });
});

routes/web.php
<?php

use App\Http\Controllers\LoginWithOTPController;
use App\Http\Controllers\SocialiteController;
use Illuminate\Support\Facades\Route;
use Illuminate\Support\Str;
/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

Route::get('/', function () {
    $readmePath = base_path('README.md');

    return view('welcome', [
        'readmeContent' => Str::markdown(file_get_contents($readmePath)),
    ]);
});



// Auth routes
require __DIR__.'/auth.php';
// Admin Routes
require('admin.php');

app/Models/Task.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Task extends Model
{
    use HasFactory;

    protected $fillable = [
        'userId',
        'taskName',
        'taskDetails',
    ];

    public function user()
    {
        return $this->hasMany(User::class,'id','userId');
    }
}

app/Http/Controllers/TaskController.php
<?php

namespace App\Http\Controllers;

use App\Models\Task;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class TaskController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index(Request $request)
    {
        if($request->user()->hasAnyRole(['admin'])){
            $data = Task::with('user')->orderBy('id','DESC')->get();
            return view('admin.task.index', compact('data'));
        } else {
            $data = Task::where('userId',Auth::id())->orderBy('id','DESC')->get();
            return view('admin.task.index', compact('data'));
        }
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        return view('admin.task.create');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {
        $request->validate([
            'taskName' => 'required',
            'taskDetails' => 'required',
        ]);

        Task::create([
            'userId' => Auth::id(),
            'taskName' => $request->taskName,
            'taskDetails' => $request->taskDetails,
        ]);
        return redirect()->route('admin.task.index')->with('success','Task created successfully.');
    }

    /**
     * Display the specified resource.
     */
    public function show(Task $task)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit($id)
    {
        $task = Task::where('id',decrypt($id))->first();
        return view('admin.task.edit',compact('task'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Task $task)
    {
        $request->validate([
            'taskName' => 'required',
            'taskDetails' => 'required',
        ]);
        $user = Task::find($request->id);
        $user->taskName = $request->taskName;
        $user->taskDetails = $request->taskDetails;
        $user->save();
        return redirect()->route('admin.task.index')->with('success','Task updated successfully.');
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy($id)
    {
        Task::where('id',decrypt($id))->delete();
        return redirect()->back()->with('success','Task deleted successfully.');
    }
}

resources/views/admin/task/create.blade.php
<x-admin>
    @section('title', 'Create Task')
    <div class="card">
        <div class="card-header">
            <h3 class="card-title">Create Task</h3>
            <div class="card-tools"><a href="{{ route('admin.task.index') }}" class="btn btn-sm btn-dark">Back</a></div>
        </div>
        <div class="card-body">
            <form action="{{ route('admin.task.store') }}" method="POST">
                @csrf
                <div class="row">
                    <div class="col-lg-12">
                        <div class="form-group">
                            <label for="taskName" class="form-label">Name:*</label>
                            <input type="text" class="form-control" name="taskName" required
                                value="{{ old('taskName') }}">
                            @error('name')
                                <span class="text-danger">{{ $message }}</span>
                            @enderror
                        </div>
                    </div>
                    <div class="col-lg-12">
                        <div class="form-group">
                            <label for="taskDetails" class="form-label">Task Details:*</label>
                            <textarea class="form-control" name="taskDetails" required
                                      value="{{ old('taskDetails') }}"></textarea>
                            @error('email')
                                <span class="text-danger">{{ $message }}</span>
                            @enderror
                        </div>
                    </div>

                    <div class="col-lg-12">
                        <div class="float-right">
                            <button class="btn btn-primary" type="submit">Save</button>
                        </div>
                    </div>
                </div>
            </form>
        </div>
    </div>
</x-admin>

resources/views/admin/task/edit.blade.php
<x-admin>
    @section('title', 'Edit Task')
    <div class="card">
        <div class="card-header">
            <h3 class="card-title">Edit Task</h3>
            <div class="card-tools"><a href="{{ route('admin.task.index') }}" class="btn btn-sm btn-dark">Back</a></div>
        </div>
        <div class="card-body">
            <form action="{{ route('admin.task.update',$task) }}" method="POST">
                @method('PUT')
                @csrf
                <input type="hidden" name="id" value="{{ $task->id }}">
                <div class="row">
                    <div class="col-lg-12">
                        <div class="form-group">
                            <label for="taskName" class="form-label">Name:*</label>
                            <input type="text" class="form-control" name="taskName" required
                                   value="{{ $task->taskName }}">
                            @error('name')
                            <span class="text-danger">{{ $message }}</span>
                            @enderror
                        </div>
                    </div>
                    <div class="col-lg-12">
                        <div class="form-group">
                            <label for="taskDetails" class="form-label">Email:*</label>
                            <textarea class="form-control" name="taskDetails" required
                                      >{{ $task->taskDetails }}</textarea>
                            @error('email')
                            <span class="text-danger">{{ $message }}</span>
                            @enderror
                        </div>
                    </div>
                    <div class="col-lg-12">
                        <div class="float-right">
                            <button class="btn btn-primary" type="submit">Save</button>
                        </div>
                    </div>
                </div>
            </form>
        </div>
    </div>
</x-admin>

resources/views/admin/task/index.blade.php
<x-admin>
    @section('title', 'Task')
    <div class="card">
        <div class="card-header">
            <h3 class="card-title">Task Table</h3>
            <div class="card-tools"><a href="{{ route('admin.task.create') }}" class="btn btn-sm btn-primary">Add</a></div>
        </div>
        <div class="card-body">
            <table class="table table-striped" id="taskTable">
                <thead>
                    <tr>
                        <th>#</th>
                        @role('admin')
                        <th>User Name</th>
                        @endrole
                        <th>Task Name</th>
                        <th>Task Details</th>
                        <th>Created</th>
                        <th>Action</th>
                        <th></th>
                    </tr>
                </thead>
                <tbody>
                    @foreach ($data as $key => $task)
                        <tr>
                            <td>{{ $key + 1 }}</td>
                            @role('admin')
                            @foreach($task->user as $uName)
                                <td>{{ $uName->name }}</td>
                            @endforeach
                            @endrole
                            <td>{{ $task->taskName }}</td>
                            <td>{{ $task->taskDetails }}</td>
                            <td>{{ $task->created_at }}</td>
                            <td>
                                <a href="{{ route('admin.task.edit', encrypt($task->id)) }}"
                                    class="btn btn-sm btn-primary">Edit</a>
                            </td>
                            <td>
                                <form action="{{ route('admin.task.destroy', encrypt($task->id)) }}" method="POST"
                                    onsubmit="return confirm('Are sure want to delete?')">
                                    @method('DELETE')
                                    @csrf
                                    <button type="submit" class="btn btn-sm btn-danger">Delete</button>
                                </form>
                            </td>
                        </tr>
                    @endforeach
                </tbody>
            </table>
        </div>
    </div>
    @section('js')
        <script>
            $(function() {
                $('#taskTable').DataTable({
                    "paging": true,
                    "searching": true,
                    "ordering": true,
                    "responsive": true,
                });
            });
        </script>
    @endsection
</x-admin>